| Flutter Impeller |

Public Member Functions | Static Public Member Functions | List of all members
impeller::LineGeometry Class Referencefinal

`#include <line_geometry.h>`

Inheritance diagram for impeller::LineGeometry:

## Public Member Functions
| LineGeometry (Point p0, Point p1, Scalar width, Cap cap)
| ~LineGeometry ()=default
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
Public Member Functions inherited from impeller::Geometry
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const

## Static Public Member Functions
static Scalar | ComputePixelHalfWidth (const Matrix &transform, Scalar width)
Static Public Member Functions inherited from impeller::Geometry
static std::shared_ptr< Geometry > | MakeFillPath (const Path &path, std::optional< Rect > inner_rect=std::nullopt)
static std::shared_ptr< Geometry > | MakeStrokePath (const Path &path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::shared_ptr< Geometry > | MakeCover ()
static std::shared_ptr< Geometry > | MakeRect (const Rect &rect)
static std::shared_ptr< Geometry > | MakeOval (const Rect &rect)
static std::shared_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, Scalar width, Cap cap)
static std::shared_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::shared_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::shared_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::shared_ptr< Geometry > | MakePointField (std::vector< Point > points, Scalar radius, bool round)

## Additional Inherited Members
Static Protected Member Functions inherited from impeller::Geometry
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)
static GeometryResult | ComputePositionUVGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Matrix &uv_transform, const Entity &entity, RenderPass &pass)

## Detailed Description

Definition at line 13 of file line_geometry.h.

## Constructor & Destructor Documentation

## ◆ LineGeometry()

impeller::LineGeometry::LineGeometry | ( | Point | p0,
|  | Point | p1,
|  | Scalar | width,
|  | Cap | cap
| ) |  |
| explicit

Definition at line 9 of file line_geometry.cc.

10 : p0_(p0), p1_(p1), width_(width), cap_(cap) {
11 FML_DCHECK(width >= 0);
12 }

## ◆ ~LineGeometry()

impeller::LineGeometry::~LineGeometry | ( |  | ) |
| default

## Member Function Documentation

## ◆ ComputePixelHalfWidth()

Scalar impeller::LineGeometry::ComputePixelHalfWidth | ( | const Matrix & | transform,
|  | Scalar | width
| ) |  |
| static

Definition at line 14 of file line_geometry.cc.

15 {
16 auto determinant = transform.GetDeterminant();
17 if (determinant == 0) {
18 return 0.0f;
19 }
20
21 Scalar min_size = 1.0f / sqrt(std::abs(determinant));
22 return std::max(width, min_size) * 0.5f;
23 }

References impeller::Matrix::GetDeterminant().

## ◆ CoversArea()

bool impeller::LineGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| override virtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 179 of file line_geometry.cc.

179 {
180 if (!transform.IsTranslationScaleOnly() || !IsAxisAlignedRect()) {
181 return false;
182 }
183 auto coverage = GetCoverage(transform);
184 return coverage.has_value() ? coverage->Contains(rect) : false;
185 }

References IsAxisAlignedRect(), and impeller::Matrix::IsTranslationScaleOnly().

## ◆ IsAxisAlignedRect()

bool impeller::LineGeometry::IsAxisAlignedRect | ( |  | ) | const
| override virtual

Reimplemented from impeller::Geometry.

Definition at line 187 of file line_geometry.cc.

187 {
188 return cap_ != Cap::kRound && (p0_.x == p1_.x || p0_.y == p1_.y);
189 }

References impeller::kRound, impeller::TPoint< T >::x, and impeller::TPoint< T >::y.

Referenced by CoversArea().

The documentation for this class was generated from the following files:

- impeller/entity/geometry/line_geometry.h
- impeller/entity/geometry/line_geometry.cc

impeller::Cap::kRound
@ kRound
impeller::TPoint::y
Type y
Definition: point.h:31
impeller::Scalar
float Scalar
Definition: scalar.h:18
impeller::LineGeometry::IsAxisAlignedRect
bool IsAxisAlignedRect() const override
Definition: line_geometry.cc:187
impeller::TPoint::x
Type x
Definition: point.h:30